﻿Imports Microsoft.VisualBasic
Imports System.Data
Imports System.Data.Common

Public Class Book
    Private _isbn As String
    Private _title As String
    Private _publish As String
    Public Property Isbn() As String
        Get
            Return Me._isbn
        End Get
        Set(ByVal value As String)
            Me._isbn = value
        End Set
    End Property
    Public Property Title() As String
        Get
            Return Me._title
        End Get
        Set(ByVal value As String)
            Me._title = value
        End Set
    End Property
    Public Property Publish() As String
        Get
            Return Me._publish
        End Get
        Set(ByVal value As String)
            Me._publish = value
        End Set
    End Property
    Public Function GetBookInfos() As ArrayList
        Dim list As New ArrayList()
        Dim setting As ConnectionStringSettings = _
            ConfigurationManager.ConnectionStrings("db")
        Dim factory As DbProviderFactory = _
            DbProviderFactories.GetFactory(setting.ProviderName)
        Using db As DbConnection = factory.CreateConnection()
            db.ConnectionString = setting.ConnectionString
            db.Open()
            Dim comm As DbCommand = factory.CreateCommand()
            comm.CommandText = "SELECT * FROM book"
            comm.Connection = db
            Dim reader As DbDataReader = comm.ExecuteReader()
            Do While reader.Read()
                Dim bok As New Book()
                bok.Isbn = reader.GetString(0)
                bok.Title = reader.GetString(1)
                bok.Publish = reader.GetString(2)
                list.Add(bok)
            Loop
        End Using
        Return list
    End Function
    Public Function GetBookInfo(ByVal isbn As String) As Book
        Dim bok As New Book()
        If isbn = Nothing Then Return bok
        Dim setting As ConnectionStringSettings = _
            ConfigurationManager.ConnectionStrings("db")
        Dim factory As DbProviderFactory = _
            DbProviderFactories.GetFactory(setting.ProviderName)
        Using db As DbConnection = factory.CreateConnection()
            db.ConnectionString = setting.ConnectionString
            db.Open()
            Dim comm As DbCommand = factory.CreateCommand()
            comm.CommandText = "SELECT * FROM book WHERE isbn=@isbn"
            comm.Connection = db
            Dim param As DbParameter = factory.CreateParameter()
            param.ParameterName = "@isbn"
            param.Value = isbn
            comm.Parameters.Add(param)
            Dim reader As DbDataReader = comm.ExecuteReader()
            If reader.Read() Then
                bok.Isbn = reader.GetString(0)
                bok.Title = reader.GetString(1)
                bok.Publish = reader.GetString(2)
            End If
        End Using
        Return bok
    End Function
    Public Function InsertBook(ByVal bok As Book) As Integer
        Dim result As Integer
        Dim setting As ConnectionStringSettings = _
            ConfigurationManager.ConnectionStrings("db")
        Dim factory As DbProviderFactory = _
            DbProviderFactories.GetFactory(setting.ProviderName)
        Using db As DbConnection = factory.CreateConnection()
            db.ConnectionString = setting.ConnectionString
            db.Open()
            Dim comm As DbCommand = factory.CreateCommand()
            comm.CommandText = "INSERT book(isbn,title,publish) VALUES(@isbn, @title, @publish)"
            comm.Connection = db
            Dim param1 As DbParameter = factory.CreateParameter()
            param1.ParameterName = "@isbn"
            param1.Value = bok.Isbn
            Dim param2 As DbParameter = factory.CreateParameter()
            param2.ParameterName = "@title"
            param2.Value = bok.Title
            Dim param3 As DbParameter = factory.CreateParameter()
            param3.ParameterName = "@publish"
            param3.Value = bok.Publish
            comm.Parameters.Add(param1)
            comm.Parameters.Add(param2)
            comm.Parameters.Add(param3)
            result = comm.ExecuteNonQuery()
        End Using
        Return result
    End Function
    Public Function UpdateBook(ByVal bok As Book) As Integer
        Dim result As Integer
        Dim setting As ConnectionStringSettings = _
            ConfigurationManager.ConnectionStrings("db")
        Dim factory As DbProviderFactory = _
            DbProviderFactories.GetFactory(setting.ProviderName)
        Using db As DbConnection = factory.CreateConnection()
            db.ConnectionString = setting.ConnectionString
            db.Open()
            Dim comm As DbCommand = factory.CreateCommand()
            comm.CommandText = "UPDATE book SET title=@title, publish=@publish WHERE isbn=@isbn"
            comm.Connection = db
            Dim param1 As DbParameter = factory.CreateParameter()
            param1.ParameterName = "@isbn"
            param1.Value = bok.Isbn
            Dim param2 As DbParameter = factory.CreateParameter()
            param2.ParameterName = "@title"
            param2.Value = bok.Title
            Dim param3 As DbParameter = factory.CreateParameter()
            param3.ParameterName = "@publish"
            param3.Value = bok.Publish
            comm.Parameters.Add(param1)
            comm.Parameters.Add(param2)
            comm.Parameters.Add(param3)
            result = comm.ExecuteNonQuery()
        End Using
        Return result
    End Function
    Public Function DeleteBook(ByVal bok As Book) As Integer
        Dim result As Integer
        Dim setting As ConnectionStringSettings = _
            ConfigurationManager.ConnectionStrings("db")
        Dim factory As DbProviderFactory = _
            DbProviderFactories.GetFactory(setting.ProviderName)
        Using db As DbConnection = factory.CreateConnection()
            db.ConnectionString = setting.ConnectionString
            db.Open()
            Dim comm As DbCommand = factory.CreateCommand()
            comm.CommandText = "DELETE FROM book WHERE isbn=@isbn"
            comm.Connection = db
            Dim param As DbParameter = factory.CreateParameter()
            param.ParameterName = "@isbn"
            param.Value = bok.Isbn
            comm.Parameters.Add(param)
            result = comm.ExecuteNonQuery()
        End Using
        Return result
    End Function
End Class
