﻿using System;
using System.Data;
using System.Data.Common;
using System.Collections;
using System.Configuration;

public class Book {
    private String _isbn;
    private String _title;
    private String _publish;
    public String Isbn{
        get{
            return this._isbn;
        }
        set{
            this._isbn = value;
        }
    }
    public String Title{
        get{
            return this._title;
        }
        set{
            this._title = value;
        }
    }
    public String Publish{
        get{
            return this._publish;
        }
        set{
            this._publish = value;
        }
    }
    public ArrayList GetBookInfos(){
        ArrayList list=new ArrayList();
        ConnectionStringSettings setting = 
            ConfigurationManager.ConnectionStrings["db"];
        DbProviderFactory factory =
            DbProviderFactories.GetFactory(setting.ProviderName);
        using(DbConnection db= factory.CreateConnection()){
            db.ConnectionString = setting.ConnectionString;
            db.Open();
            DbCommand comm= factory.CreateCommand();
            comm.CommandText = "SELECT * FROM book";
            comm.Connection = db;
            DbDataReader reader= comm.ExecuteReader();
            while(reader.Read()){
                Book bok =new Book();
                bok.Isbn = reader.GetString(0);
                bok.Title = reader.GetString(1);
                bok.Publish = reader.GetString(2);
                list.Add(bok);
            }
        }
        return list;
    }
    public int InsertBook(Book bok){
        int result;
        ConnectionStringSettings setting = 
            ConfigurationManager.ConnectionStrings["db"];
        DbProviderFactory factory =
            DbProviderFactories.GetFactory(setting.ProviderName);
        using(DbConnection db= factory.CreateConnection()){
            db.ConnectionString = setting.ConnectionString;
            db.Open();
            DbCommand comm= factory.CreateCommand();
            comm.CommandText = "INSERT book(isbn,title,publish) VALUES(@isbn, @title, @publish)";
            comm.Connection = db;
            DbParameter param1= factory.CreateParameter();
            param1.ParameterName = "@isbn";
            param1.Value = bok.Isbn;
            DbParameter param2= factory.CreateParameter();
            param2.ParameterName = "@title";
            param2.Value = bok.Title;
            DbParameter param3= factory.CreateParameter();
            param3.ParameterName = "@publish";
            param3.Value = bok.Publish;
            comm.Parameters.Add(param1);
            comm.Parameters.Add(param2);
            comm.Parameters.Add(param3);
            result = comm.ExecuteNonQuery();
        }
        return result;
    }
    public int UpdateBook(Book bok){
        int result;
        ConnectionStringSettings setting = 
            ConfigurationManager.ConnectionStrings["db"];
        DbProviderFactory factory =
            DbProviderFactories.GetFactory(setting.ProviderName);
        using(DbConnection db= factory.CreateConnection()){
            db.ConnectionString = setting.ConnectionString;
            db.Open();
            DbCommand comm= factory.CreateCommand();
            comm.CommandText = "UPDATE book SET title=@title, publish=@publish WHERE isbn=@isbn";
            comm.Connection = db;
            DbParameter param1= factory.CreateParameter();
            param1.ParameterName = "@isbn";
            param1.Value = bok.Isbn;
            DbParameter param2= factory.CreateParameter();
            param2.ParameterName = "@title";
            param2.Value = bok.Title;
            DbParameter param3= factory.CreateParameter();
            param3.ParameterName = "@publish";
            param3.Value = bok.Publish;
            comm.Parameters.Add(param1);
            comm.Parameters.Add(param2);
            comm.Parameters.Add(param3);
            result = comm.ExecuteNonQuery();
        }
        return result;
    }
    public int DeleteBook(Book bok){
        int result;
        ConnectionStringSettings setting = 
            ConfigurationManager.ConnectionStrings["db"];
        DbProviderFactory factory =
            DbProviderFactories.GetFactory(setting.ProviderName);
        using(DbConnection db= factory.CreateConnection()){
            db.ConnectionString = setting.ConnectionString;
            db.Open();
            DbCommand comm= factory.CreateCommand();
            comm.CommandText = "DELETE FROM book WHERE isbn=@isbn";
            comm.Connection = db;
            DbParameter param= factory.CreateParameter();
            param.ParameterName = "@isbn";
            param.Value = bok.Isbn;
            comm.Parameters.Add(param);
            result = comm.ExecuteNonQuery();
        }
        return result;
    }
}
