﻿<%@ Page Language="VB" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">

    Protected Sub gv_RowUpdating(ByVal sender As Object, ByVal e As GridViewUpdateEventArgs)
        If Not Page.IsValid Then
            e.Cancel = True
        End If
    End Sub
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>GridViewコントロール</title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:GridView ID="gv" runat="server" AllowPaging="True" AllowSorting="True" AutoGenerateColumns="False"
            BackColor="White" BorderColor="#CCCCCC" BorderStyle="None" BorderWidth="1px"
            CellPadding="4" DataKeyNames="isbn" DataSourceID="sds" ForeColor="Black" GridLines="Horizontal" OnRowUpdating="gv_RowUpdating">
            <FooterStyle BackColor="#CCCC99" ForeColor="Black" />
            <SelectedRowStyle BackColor="#CC3333" Font-Bold="True" ForeColor="White" />
            <PagerStyle BackColor="White" ForeColor="Black" HorizontalAlign="Right" />
            <HeaderStyle BackColor="#333333" Font-Bold="True" ForeColor="White" />
            <Columns>
                <asp:ImageField DataAlternateTextField="title" DataImageUrlField="isbn" DataImageUrlFormatString="http://www.wings.msn.to/books/{0}/{0}_logo.jpg"
                    InsertVisible="False" ReadOnly="True" SortExpression="isbn">
                </asp:ImageField>
                <asp:HyperLinkField DataNavigateUrlFields="isbn" DataNavigateUrlFormatString="http://www.wings.msn.to/index.php/-/A-03/{0}/"
                    DataTextField="isbn" HeaderText="ISBNコード" />
                <asp:BoundField DataField="title" HeaderText="タイトル" SortExpression="title" />
                <asp:BoundField DataField="price" HeaderText="価格"
                    HtmlEncode="False" SortExpression="price" DataFormatString="{0:#,###円}" />
                <asp:BoundField DataField="publish" HeaderText="出版社" SortExpression="publish" />
                <asp:TemplateField HeaderText="刊行日" SortExpression="publishDate">
                    <EditItemTemplate>
                        <asp:TextBox ID="txtPublishDate" runat="server" Text='<%# Bind("publishDate", "{0:yyyy/MM/dd}") %>' />
                        <asp:CompareValidator ID="cmpDate" runat="server" ControlToValidate="txtPublishDate"
                            Display="Dynamic" ErrorMessage="yyyy/MM/ddの形式で入力してください。" Operator="DataTypeCheck"
                            SetFocusOnError="True" Type="Date">*</asp:CompareValidator>
                    </EditItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="Label1" runat="server" Text='<%# Eval("publishDate", "{0:yyyy年MM月dd日}") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:CommandField ButtonType="Button" ShowDeleteButton="True" ShowEditButton="True" />
            </Columns>
        </asp:GridView>
        <asp:SqlDataSource ID="sds" runat="server" ConflictDetection="CompareAllValues" ConnectionString="<%$ ConnectionStrings:db %>"
            DeleteCommand="DELETE FROM [book] WHERE [isbn] = @original_isbn AND [title] = @original_title AND [price] = @original_price AND [publish] = @original_publish AND [publishDate] = @original_publishDate"
            InsertCommand="INSERT INTO [book] ([isbn], [title], [price], [publish], [publishDate]) VALUES (@isbn, @title, @price, @publish, @publishDate)"
            OldValuesParameterFormatString="original_{0}" SelectCommand="SELECT [isbn], [title], [price], [publish], [publishDate] FROM [book]"
            UpdateCommand="UPDATE [book] SET [title] = @title, [price] = @price, [publish] = @publish, [publishDate] = @publishDate WHERE [isbn] = @original_isbn AND [title] = @original_title AND [price] = @original_price AND [publish] = @original_publish AND [publishDate] = @original_publishDate">
            <DeleteParameters>
                <asp:Parameter Name="original_isbn" Type="String" />
                <asp:Parameter Name="original_title" Type="String" />
                <asp:Parameter Name="original_price" Type="Int32" />
                <asp:Parameter Name="original_publish" Type="String" />
                <asp:Parameter Name="original_publishDate" Type="DateTime" />
            </DeleteParameters>
            <UpdateParameters>
                <asp:Parameter Name="title" Type="String" />
                <asp:Parameter Name="price" Type="Int32" />
                <asp:Parameter Name="publish" Type="String" />
                <asp:Parameter Name="publishDate" Type="DateTime" />
                <asp:Parameter Name="original_isbn" Type="String" />
                <asp:Parameter Name="original_title" Type="String" />
                <asp:Parameter Name="original_price" Type="Int32" />
                <asp:Parameter Name="original_publish" Type="String" />
                <asp:Parameter Name="original_publishDate" Type="DateTime" />
            </UpdateParameters>
            <InsertParameters>
                <asp:Parameter Name="isbn" Type="String" />
                <asp:Parameter Name="title" Type="String" />
                <asp:Parameter Name="price" Type="Int32" />
                <asp:Parameter Name="publish" Type="String" />
                <asp:Parameter Name="publishDate" Type="DateTime" />
            </InsertParameters>
        </asp:SqlDataSource>
        <asp:ValidationSummary ID="validSmry" runat="server" ShowMessageBox="True" ShowSummary="False" />
    
    </div>
    </form>
</body>
</html>
