﻿<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data.Common" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">

    protected void Page_Load(Object sender, EventArgs e){
        if(!Page.IsPostBack){
            this.SetTreeNode(0, tv.Nodes);
        }
    }
    private void SetTreeNode(int parent, TreeNodeCollection nodes){
        ConnectionStringSettings setting= 
            ConfigurationManager.ConnectionStrings["db"];
        DbProviderFactory factory = 
            DbProviderFactories.GetFactory(setting.ProviderName);
        using(DbConnection db = factory.CreateConnection()){
            db.ConnectionString = setting.ConnectionString;
            DbCommand comm= factory.CreateCommand();
            comm.CommandText = 
              "SELECT id,url,title,description FROM sitemap WHERE parent=@parent";
            comm.Connection = db;
            DbParameter param = factory.CreateParameter();
            param.ParameterName = "@parent";
            param.Value = parent;
            comm.Parameters.Add(param);
            db.Open();
            DbDataReader reader= comm.ExecuteReader();
            while(reader.Read()){
               TreeNode node=new TreeNode();
              node.NavigateUrl = reader.GetString(1);
              node.Text = reader.GetString(2);
              node.Value = reader.GetInt32(0).ToString();
              node.PopulateOnDemand = true;
              node.ToolTip = reader.GetString(3);
              nodes.Add(node);
            }
        }
    }
    protected void tv_TreeNodePopulate(Object sender, TreeNodeEventArgs e){
        this.SetTreeNode(Int32.Parse(e.Node.Value), e.Node.ChildNodes);
    }
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Nodesプロパティ</title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:TreeView ID="tv" runat="server" LineImagesFolder="~/TreeLineImages" NodeIndent="10"
            ShowLines="True" PopulateNodesFromClient="True" OnTreeNodePopulate="tv_TreeNodePopulate" EnableClientScript="False" ExpandDepth="0">
            <ParentNodeStyle Font-Bold="False" />
            <HoverNodeStyle Font-Underline="True" ForeColor="#5555DD" />
            <SelectedNodeStyle Font-Underline="True" ForeColor="#5555DD" HorizontalPadding="0px"
                VerticalPadding="0px" />
            <NodeStyle Font-Names="Verdana" Font-Size="8pt" ForeColor="Black" HorizontalPadding="0px"
                NodeSpacing="0px" VerticalPadding="0px" />
        </asp:TreeView>
    
    </div>
    </form>
</body>
</html>
